import statsmodels.api as sm
import pandas as pd 
import xlwings as xw
import numpy as np
import pyttsx3
#from openpyxl.utils.cell import get_column_letter

def get_column_letter(num):
    letters = ''
    while num:
        mod = (num - 1) % 26
        letters += chr(mod + 65)
        num = (num - 1) // 26
    return ''.join(reversed(letters))

def fx(x,pwr):
  if pwr > 0:
    return x**pwr
  elif pwr < 0:
    return 1/x**abs(pwr)
  else:
    return np.log(x)

e = pyttsx3.init()
rate = e.getProperty('rate')
e.setProperty('rate', rate-50)

# Load your data (replace with your actual data)
wb = xw.Book('bestrathet6.xlsx')
sheetData = wb.sheets['Data']
sheetTransf = wb.sheets['Transf']
sheetRes = wb.sheets['Results']
sheetList = wb.sheets['List']
sheetYt = wb.sheets['Yt']
sheetXt1 = wb.sheets['Xt1']
sheetXt2 = wb.sheets['Xt2']
sheetXt3 = wb.sheets['Xt3']
sheetYXt1 = wb.sheets['YXt1']
sheetYXt2 = wb.sheets['YXt2']
sheetYXt3 = wb.sheets['YXt3']
# clear sheets
sheetList.range('A2:Z100000').value = ""
sheetYt.range('A1:Z10000').value = ""
sheetXt1.range('A1:Z10000').value = ""
sheetXt2.range('A1:Z10000').value = ""
sheetXt3.range('A1:Z10000').value = ""
sheetYXt1.range('A1:Z10000').value = ""
sheetYXt2.range('A1:Z10000').value = ""
sheetYXt3.range('A1:Z10000').value = ""

row = 1
while 1:
  row += 1
  if sheetData.range(row,1).value is None:
    break
maxrows = row - 1

yPwrs = sheetTransf.range("A2:A4").value
x1Pwrs = sheetTransf.range("B2:B4").value
x2Pwrs = sheetTransf.range("C2:C4").value
x3Pwrs = sheetTransf.range("D2:D4").value
yx1Pwrs = sheetTransf.range("E2:E4").value
yx2Pwrs = sheetTransf.range("F2:F4").value
yx3Pwrs = sheetTransf.range("G2:G4").value
minAdjR2 = sheetTransf.range("H2").value

yCols = 0
for yPwr in np.arange(yPwrs[0],yPwrs[2]+yPwrs[1],yPwrs[1]):
  yCols += 1
  for row in range(2,maxrows+1):
    sheetYt.range(row-1,yCols).value = fx(sheetData.range(row,1).value,yPwr)

x1Cols = 0
for x1Pwr in np.arange(x1Pwrs[0],x1Pwrs[2]+x1Pwrs[1],x1Pwrs[1]):
  x1Cols += 1
  for row in range(2,maxrows+1):
    sheetXt1.range(row-1,x1Cols).value = fx(sheetData.range(row,2).value,x1Pwr)

x2Cols = 0
for x2Pwr in np.arange(x2Pwrs[0],x2Pwrs[2]+x2Pwrs[1],x2Pwrs[1]):
  x2Cols += 1
  for row in range(2,maxrows+1):
    sheetXt2.range(row-1,x2Cols).value = fx(sheetData.range(row,3).value,x2Pwr)

x3Cols = 0
for x3Pwr in np.arange(x3Pwrs[0],x3Pwrs[2]+x3Pwrs[1],x3Pwrs[1]):
  x3Cols += 1
  for row in range(2,maxrows+1):
    sheetXt3.range(row-1,x3Cols).value = fx(sheetData.range(row,4).value,x3Pwr)


yx1Cols = 0
for yx1Pwr in np.arange(yx1Pwrs[0],yx1Pwrs[2]+yx1Pwrs[1],yx1Pwrs[1]):
  yx1Cols += 1
  for row in range(2,maxrows+1):
    sheetYXt1.range(row-1,yx1Cols).value = fx(sheetData.range(row,2).value,yx1Cols)

yx2Cols = 0
for yx2Pwr in np.arange(yx2Pwrs[0],yx2Pwrs[2]+yx2Pwrs[1],yx2Pwrs[1]):
  yx2Cols += 1
  for row in range(2,maxrows+1):
    sheetYXt2.range(row-1,yx2Cols).value = fx(sheetData.range(row,3).value,yx2Cols)

yx3Cols = 0
for yx3Pwr in np.arange(yx3Pwrs[0],yx3Pwrs[2]+yx3Pwrs[1],yx3Pwrs[1]):
  yx3Cols += 1
  for row in range(2,maxrows+1):
    sheetYXt3.range(row-1,yx3Cols).value = fx(sheetData.range(row,4).value,yx3Cols)

bestAdjR2 = 0
gRow = 1

e.say("Initialization Done")
e.runAndWait()

yCols = 0
for yPwr in np.arange(yPwrs[0],yPwrs[2]+yPwrs[1],yPwrs[1]):
  yCols += 1
  s = get_column_letter(yCols)
  s2 = s + "1:" + s + str(maxrows-1)
  Ysr = sheetYt.range(s2)
  Ysr.copy()
  Ydr = sheetData.range("E2")
  Ydr.paste()

  x1Cols = 0  
  for x1Pwr in np.arange(x1Pwrs[0],x1Pwrs[2]+x1Pwrs[1],x1Pwrs[1]):
    x1Cols += 1
    s = get_column_letter(x1Cols)
    s2 = s + "1:" + s + str(maxrows-1)
    Xsr = sheetXt1.range(s2)
    Xsr.copy()
    Xdr = sheetData.range("F2")
    Xdr.paste()

    x2Cols = 0  
    for x2Pwr in np.arange(x2Pwrs[0],x2Pwrs[2]+x2Pwrs[1],x2Pwrs[1]):
      x2Cols += 1
      s = get_column_letter(x2Cols)
      s2 = s + "1:" + s + str(maxrows-1)
      Xsr = sheetXt2.range(s2)
      Xsr.copy()
      Xdr = sheetData.range("G2")
      Xdr.paste()

      x3Cols = 0  
      for x3Pwr in np.arange(x3Pwrs[0],x3Pwrs[2]+x3Pwrs[1],x3Pwrs[1]):
        x3Cols += 1
        s = get_column_letter(x3Cols)
        s2 = s + "1:" + s + str(maxrows-1)
        Xsr = sheetXt3.range(s2)
        Xsr.copy()
        Xdr = sheetData.range("H2")
        Xdr.paste()

        yx1Cols = 0  
        for yx1Pwr in np.arange(yx1Pwrs[0],yx1Pwrs[2]+yx1Pwrs[1],yx1Pwrs[1]):
          yx1Cols += 1
          s = str(maxrows)
          s1 = "E2:E" + s
          s2 = "B2:B" + s
          s3 = "I2:I" + s
          xt1 = np.array(sheetData[s2].value)
          if yx1Pwr > 0:
            xt1 = xt1**yx1Pwr
          elif yx1Pwr < 0:
            xt1 = 1/xt1**abs(yx1Pwr)
          else:
            xt1 = np.log(xt1)
      
          xt1 = -1 * np.array(sheetData[s1].value) * xt1
          sheetData.range(s3).options(transpose=True).value = xt1
    
          yx2Cols = 0  
          for yx2Pwr in np.arange(yx2Pwrs[0],yx2Pwrs[2]+yx2Pwrs[1],yx2Pwrs[1]):
            yx2Cols += 1
            s = str(maxrows)
            s1 = "E2:E" + s
            s2 = "C2:C" + s
            s3 = "J2:J" + s
            xt2 = np.array(sheetData[s2].value)
            if yx2Pwr > 0:
              xt2 = xt2**yx2Pwr
            elif yx2Pwr < 0:
              xt2 = 1/xt2**abs(yx2Pwr)
            else:
              xt2 = np.log(xt2)
      
            xt2 = -1 * np.array(sheetData[s1].value) * xt2
            sheetData.range(s3).options(transpose=True).value = xt2

            yx3Cols = 0  
            for yx3Pwr in np.arange(yx3Pwrs[0],yx3Pwrs[2]+yx3Pwrs[1],yx3Pwrs[1]):
              yx3Cols += 1
              s = str(maxrows)
              s1 = "E2:E" + s
              s2 = "D2:D" + s
              s3 = "K2:K" + s
              xt3 = np.array(sheetData[s2].value)
              if yx3Pwr > 0:
                xt3 = xt3**yx3Pwr
              elif yx3Pwr < 0:
                xt3 = 1/xt3**abs(yx3Pwr)
              else:
                xt3 = np.log(xt3)
      
              xt3 = -1 * np.array(sheetData[s1].value) * xt3
              sheetData.range(s3).options(transpose=True).value = xt3
          
              data = sheetData.range((2,5),(maxrows,11)).value
     
              # Convert data to a pandas DataFrame
              df = pd.DataFrame(data)
              df.columns = ['Yt','Xt1','Xt2','Xt3','YXt1','YXt2','YXt3']
              # Define dependent and independent variables
              y = df['Yt']
              X = df[['Xt1','Xt2','Xt3','YXt1','YXt2','YXt3']]
              # Add a constant to the independent variables (for the intercept term)
              X = sm.add_constant(X)

              # Fit the model
              model = sm.OLS(y, X).fit()
    
              if model.rsquared_adj >= bestAdjR2:
                bestAdjR2 = model.rsquared_adj
                bestYpwr = yPwr
                bestX1pwr = x1Pwr
                bestX2pwr = x2Pwr
                bestX3pwr = x3Pwr
                bestYX1pwr = yx1Pwr
                bestYX2pwr = yx2Pwr         
                bestYX3pwr = yx3Pwr   
                bestModel = model
      
              if model.rsquared_adj >= minAdjR2:
                gRow += 1
                sheetList.range((gRow,1)).value = model.rsquared_adj
                sheetList.range((gRow,2)).value = yPwr
                sheetList.range((gRow,3)).value = x1Pwr
                sheetList.range((gRow,4)).value = x2Pwr
                sheetList.range((gRow,5)).value = yx1Pwr
                sheetList.range((gRow,6)).value = yx2Pwr    
                sheetList.range((gRow,7)).value = yx3Pwr  
                sheetList.range((gRow,8)).value= model.params.iloc[0]
                sheetList.range((gRow,9)).value= model.params.iloc[1]
                sheetList.range((gRow,10)).value= model.params.iloc[2]
                sheetList.range((gRow,11)).value= model.params.iloc[3]
                sheetList.range((gRow,12)).value= model.params.iloc[4]
                sheetList.range((gRow,13)).value= model.params.iloc[5]
                sheetList.range((gRow,14)).value= model.params.iloc[6]

model = bestModel

# Print the summary of the best regression results
print(model.summary())
print("Best Y power", bestYpwr)
print("Best numerator X1 power", bestX1pwr)
print("Best numerator X2 power", bestX2pwr)
print("Best numerator X3 power", bestX3pwr)
print("Best denominator X1 power", bestYX1pwr)
print("Best denominator X2 power", bestYX2pwr)
print("Best denominator X3 power", bestYX3pwr)

sheetRes.range("B1").value = model.rsquared_adj
sheetRes.range("B2").value = model.fvalue
sheetRes.range("B3").value = model.f_pvalue
sheetRes.range("B4").value = model.aic
sheetRes.range("D2").value = bestYpwr
sheetRes.range("F2").value = bestX1pwr
sheetRes.range("G2").value = bestX2pwr
sheetRes.range("H2").value = bestX3pwr
sheetRes.range("I2").value = bestYX1pwr
sheetRes.range("J2").value = bestYX2pwr
sheetRes.range("K2").value = bestYX3pwr
sheetRes.range("E3").value = model.params.iloc[0]
sheetRes.range("F3").value = model.params.iloc[1]
sheetRes.range("G3").value = model.params.iloc[2]
sheetRes.range("H3").value = model.params.iloc[3]
sheetRes.range("I3").value = model.params.iloc[4]
sheetRes.range("J3").value = model.params.iloc[5]
sheetRes.range("K3").value = model.params.iloc[6]
sheetRes.range("E4").value = model.pvalues.iloc[0]
sheetRes.range("F4").value = model.pvalues.iloc[1]
sheetRes.range("G4").value = model.pvalues.iloc[2]
sheetRes.range("H4").value = model.pvalues.iloc[3]
sheetRes.range("I4").value = model.pvalues.iloc[4]
sheetRes.range("J4").value = model.pvalues.iloc[5]
sheetRes.range("K4").value = model.pvalues.iloc[6]

e.say("Calculations Done")
e.runAndWait()